
#define USE_TI89              // Compile pour la TI-89
#define USE_TI92PLUS          // Compile pour la TI-92+
#define USE_V200              // Compile pour la V200
#define OPTIMIZE_ROM_CALLS    // Utilise la ROM Call Optimisation (tant mieux !)
#define NO_EXIT_SUPPORT       // Les instructions 'exit' et 'atexit' ne peuvent ainsi plus fonctionner et a fait encore gagner de la place !
#define MIN_AMS 100

#include <tigcclib.h>         // Inclus tous les Header Files

#include "extgraph.h"
#include "initialise.h"
#include "clavier.h"
#include "fonts.h"
#include "images.h"
#include "graphiques.h"
#include "divers.h"
#include "menus.h"
#include "tests.h"


//==================================================================================//
//									Compil avec TIGCC version 0.96 beta 8													//
//==================================================================================//

//===================================================================================//
//																																									 //
//														Code du jeu en lui-mme			     											 //
//									    																														 //
//===================================================================================//

short Jeu(void)				//	Renvoie le nombre de parties joues en link
{
	char extension[] = "TEMP"; //	Extension de la variable de sauvegarde lors d'une 'QUICK_EXIT_SAVE'
	
	short i;						//	Variables  tout faire
	short j;						//	
	
	short niveau;				//
	short position = 0;	//
	short piece = 0;		// 
	short next_piece;		//	Se rapporte directement aux blocs
	short x_piece = 0;	//
	short y_piece = 0;	//
	short x_shadow;			//
	short y_shadow;			//
	
	unsigned long score;												 //
	short lines;																 //
	short high_blocs;														 //
	short new_lines;														 // Se rapporte aux scores, lignes,
	short game_over = 0;														 // aux entres et sorties de la 
	short win_flag;															 // boucle du jeu
  short level_score[4] = {40, 100, 300, 1200}; //
  short decompte_score = 0;										 //
  static short wins = 0;											 //
  static short losses = 0;										 //	
	
	char buffer_link[1];		// Sert  la connexion en mode link
		
	short level_vitesse[18] = {1360, 1250, 1140, 1030, 920, 810, 700, 590, 480, 370, 300, 240, 190, 150, 120, 100, 80, 60};
	short compteur = 0;//
	short repetition;  //
	short tampon;			 // Se rapporte  la vitesse du jeu ainsi qu' la gestion
	short vieille_t;	 // des touches pendant le jeu
	short touche;      //
	short GAUCHE;			 //
	short DROITE;			 //
	short FLAG_BAS;		 //
	
	high_blocs = 96-12*high;
	new_lines = 0;
	win_flag = 0;	
	
	repetition = 0;
	vieille_t = 0;
	GAUCHE = (TI89 ? 0x2: 0x10);
	DROITE = (TI89 ? 0x8: 0x40);
	FLAG_BAS = 0;
	
	
	//===================================================================================//
	//											Mise en place du dcor																			 //
	//===================================================================================//
	
	if(!QUICK_EXIT_SAVE)
	{
		FonduBas(EFFACE_DEUX_PLANS);
	}
	
	if(QUICK_EXIT_SAVE)				// On restaure le dcor et les autres variables
	{													// sauvegardes lors d'une 'QUICK_EXIT_SAVE'	
		piece = *(unsigned short *)(Sauvegarde+7682);
		next_piece = *(unsigned short *)(Sauvegarde+7684);
		compteur = *(unsigned short *)(Sauvegarde+7686);
		decompte_score = *(unsigned short *)(Sauvegarde+7688);
		position = *(unsigned short *)(Sauvegarde+7690);
		x_piece = *(unsigned short *)(Sauvegarde+7692);
		y_piece = *(unsigned short *)(Sauvegarde+7694);
		niveau = *(unsigned short *)(Sauvegarde+7696);
		lines = *(unsigned short *)(Sauvegarde+7698);
		score = *(unsigned long *)(Sauvegarde+7700);
		x_shadow = *(unsigned short *)(Sauvegarde+7704);
		y_shadow = *(unsigned short *)(Sauvegarde+7706);
	}
	else		// autrement, on commence un jeu normal
	{
		niveau = level;	
		lines = (link ? 30 : 0);
		score = 0;
		
		if(!TI89)
		{
			FondEcran();
			DessineRectPlein(0, -14, 111, 0, 0, GRIS_CLAIR);
			DessineRectPlein(0, -14, 111, 0, 0, GRIS_FONCE);
			DessineRectPlein(0, 96, 111, 111, 0, GRIS_CLAIR);
			DessineRectPlein(0, 96, 111, 111, 0, GRIS_FONCE);
			EffacePlans();
		}
	
		for(i = -1; i < 7; i ++)
		{
			Sprite16_GRIS_XOR(0, 16*i, brique_0, brique_1);
			Sprite16_GRIS_XOR(96, 16*i, brique_0, brique_1);
		}
		
	
		for(i = 1; i < 6; i ++)
		{
			Sprite16_GRIS_XOR(16*i, 96, brique_0, brique_1);
		}
	
		DessineBlocs(2*high);
		
		if(high != 0)
		{
			EnvoieByte(buffer_link, high_blocs+23);
		}
	 																																					
	//===================================================================================//
	
		DessineRectPlein(112, 0, 159, 23, 4, GRIS_CLAIR);
		DessineRectPlein(112, 0, 159, 23, 4, GRIS_FONCE);
		
		if(!link)
		{
			AfficheChaine(116, 2, "SCORE", 2, GRIS_FONCE, GROS);
			AfficheChaine(117, 3, "SCORE", 2, GRIS_CLAIR, GROS);
			AfficheNb(112, 14, score, 6, 2, GRIS_FONCE, GROS);
		}
		else
		{
			DessineRectPlein(126, 2, 145, 21, 0, GRIS_CLAIR);
			DessineRectPlein(126, 2, 145, 21, 0, GRIS_FONCE);
			Sprite16_GRIS_XOR(128, 4, (joueur == MARIO ? mario_0: luigi_0), (joueur == MARIO ? mario_1: luigi_1));
		}
		
		DessineRectPlein(112, 25, 159, 48, 4, GRIS_FONCE);
		AfficheChaine(116, 27, "LEVEL", 2, GRIS_FONCE, GROS);
		AfficheChaine(117, 28, "LEVEL", 2, GRIS_CLAIR, GROS);
		AfficheNb(128, 39, niveau, 2, 2, GRIS_FONCE, GROS);
		DessineRectPlein(112, 50, 159, 72, 4, GRIS_CLAIR);
		AfficheChaine(116, 51, "LINES", 2, GRIS_CLAIR, GROS);
		AfficheChaine(117, 52, "LINES", 2, GRIS_FONCE, GROS);
		AfficheNb(123, 63, lines, 3, 2, GRIS_FONCE, GROS);
		AfficheChaine(120, 75, "NEXT", (next ? 2: 3), GRIS_CLAIR, GROS);
		AfficheChaine(120, 75, "NEXT", (next ? 2: 3), GRIS_FONCE, GROS);
		
		if(link)
		{
			DessineRectPlein(101, 0, 107, 96, 0, GRIS_CLAIR);
			DessineRectPlein(101, 0, 107, 96, 0, GRIS_FONCE);
			for(i = 0; i <= 96; i += 6)
			{
				DessineLigne(101, i, 101, i, 4, GRIS_CLAIR);
				DessineLigne(101, i, 101, i, 4, GRIS_FONCE);
				DessineLigne(107, i, 107, i, 4, GRIS_CLAIR);
				DessineLigne(107, i, 107, i, 4, GRIS_FONCE);
			}
		}
		next_piece = random(7);
	}
	
	if(!QUICK_EXIT_SAVE)
	{
		FonduHaut();
	}
	
	
	Debut:
	
	if(QUICK_EXIT_SAVE)
	{		
		EffetLCD(Sauvegarde+2, Sauvegarde+2+LCD_SIZE);
		AfficheQuit(&game_over);
		QUICK_EXIT_SAVE = 0;
	}
	else
	{
		piece = next_piece;
		next_piece = random(7);
		compteur = 0;
		decompte_score = 0;
		position = 0;
		x_piece = 40;
		y_piece = -12;
		x_shadow = 40;
		y_shadow = -12;
		game_over = TestCollision(40, -12, 0, piece);
		DessineShadow(&x_shadow, &y_shadow, piece, 0);
		AffichePiece(40, -12, piece, 0);
		
		if(next)
		{
			EffacePiece(120, 75, piece, 0);
			AffichePiece(120, 75, next_piece, 0);
		}
	}
	
	//===================================================================================//
	//															  Dbut de la boucle while													 //
	//===================================================================================//
	while(!game_over)
	{	
		
		if((++ compteur)%(level_vitesse[niveau]) == 0)
		{
			EffacePiece(x_piece, y_piece, piece, position);
			EffaceShadow(x_shadow, y_shadow, piece, position);
			decompte_score += (DIAMAND == 0 ? 1: 0);
			if(TestCollision(x_piece, y_piece+6, position, piece))
			{
				AffichePiece(x_piece, y_piece, piece, position);
				new_lines = TestLignes(y_piece);
				lines += (link ? -new_lines: new_lines);
				lines = (lines < 0 ? 0: lines);
				AfficheNb(123, 63, lines, 3, 4, GRIS_FONCE, GROS);
				if(!link)
				{
					AfficheNb(112, 14, score, 6, 2, GRIS_FONCE, GROS);
				}
				score += ((y_piece+18)/6-decompte_score);
				if(new_lines != 0)
				{
					score += level_score[new_lines-1]*(niveau+1);
				}	 
				if(link)
				{	
					if(y_piece < high_blocs || new_lines != 0)
					{	
				    i = TestHauteur((y_piece < high_blocs ? y_piece: high_blocs)+6*new_lines);
				    high_blocs = (i > 0 ? i: 0);
				    EnvoieByte(buffer_link, high_blocs+23); 
					}
					if(new_lines >= 2)
					{
						EnvoieByte(buffer_link, new_lines-1);
					}
					if(lines <= 0)
					{
						EnvoieByte(buffer_link, 21);
						game_over = 1;				// J'ai fini (j'ai fait au moins 30 lignes) 
						win_flag = 1;					// et je me casse!
					}
				}
				else
				{
					AfficheNb(112, 14, score, 6, 2, GRIS_FONCE, GROS);
				}			 
				if((link ? (30-lines)/10: lines/10) >= (niveau+1))
				{
					AfficheNb(128, 39, niveau, 2, 2, GRIS_FONCE, GROS);
					niveau ++;
					AfficheNb(128, 39, niveau, 2, 2, GRIS_FONCE, GROS);
				}			
				if(next)
				{
					EffacePiece(120, 75, piece, 0);
					AffichePiece(120, 75, next_piece, 0);
				}
				 
				FLAG_BAS = _keytest(RR_DOWN);	// Si on a laiss appuye la touche 'BAS', 
				goto Debut;			// celle-ci ne peut refonctionner que si on la relche.
			}
			y_piece += 6;
			DessineShadowSansChercher(x_shadow, y_shadow, piece, position);
			AffichePiece(x_piece, y_piece, piece, position);
		}
		
		PressionTouche(TESTE_ET_SORT);
		tampon = vieille_t;
	  touche = _rowread(0xFFFE);
	  vieille_t = touche;
	  
	  if(touche != tampon)
	   repetition  = 0;
	  if(repetition++%190 != 0)
	   touche &= ~tampon;
		
		FLAG_BAS = (_keytest(RR_DOWN)? FLAG_BAS: 0);
		// Si on a appuy sur la touche 'BAS', alors la valeur de FLAG_BAS reste 
		// inchange (elle reste 'appuye'), sinon (si on l'a relche  un moment
		// ou  un autre) FLAG_BAS prend la valeur 0 (la touche 'BAS' peut alors
		// refonctionner).
		
		if(_keytest(RR_DOWN) && FLAG_BAS == 0)
		{
			DIAMAND = 1;
			FLAG_BAS = 0;
			if(compteur%60 == 0)
			{
				EffaceShadow(x_shadow, y_shadow, piece, position);
				EffacePiece(x_piece, y_piece, piece, position);
				if(!TestCollision(x_piece, y_piece+6, position, piece))
	  	 	 y_piece += 6;
	  	 	DessineShadowSansChercher(x_shadow, y_shadow, piece, position);
	  		AffichePiece(x_piece, y_piece, piece, position);
			}	
		}
		
		else if(HAUT || SECOND)
		{
			EffaceShadow(x_shadow, y_shadow, piece, position);
			EffacePiece(x_piece, y_piece, piece, position);
			if(!TestCollision(x_piece, y_piece, (position == 3 ? 0: position+1), piece))
			 position = (position == 3 ? 0: position+1);
			x_shadow = x_piece;
			y_shadow = y_piece;
			DessineShadow(&x_shadow, &y_shadow, piece, position);
			AffichePiece(x_piece, y_piece, piece, position);
		}
	  
	  else if(SHIFT)
	  {
	  	EffaceShadow(x_shadow, y_shadow, piece, position);
	  	EffacePiece(x_piece, y_piece, piece, position);
	  	if(!TestCollision(x_piece, y_piece, (position == 0 ? 3: position-1), piece))
			 position = (position == 0 ? 3: position-1);
			x_shadow = x_piece;
			y_shadow = y_piece;
			DessineShadow(&x_shadow, &y_shadow, piece, position);
			AffichePiece(x_piece, y_piece, piece, position);
	  }
	  
	  else if(touche == GAUCHE)
	  {
	  	EffaceShadow(x_shadow, y_shadow, piece, position);
	  	EffacePiece(x_piece, y_piece, piece, position);
	  	if(!TestCollision(x_piece-8, y_piece, position, piece))
	  	 x_piece -= 8;
	  	x_shadow = x_piece;
			y_shadow = y_piece;
	  	DessineShadow(&x_shadow, &y_shadow, piece, position);
	  	AffichePiece(x_piece, y_piece, piece, position);
	  }
	  
	  else if(touche == DROITE)
	  {
	  	EffaceShadow(x_shadow, y_shadow, piece, position);
	  	EffacePiece(x_piece, y_piece, piece, position);
	  	if(!TestCollision(x_piece+8, y_piece, position, piece))
	  	 x_piece += 8;
	  	x_shadow = x_piece;
			y_shadow = y_piece;
	  	DessineShadow(&x_shadow, &y_shadow, piece, position);
	  	AffichePiece(x_piece, y_piece, piece, position);
	  }
		
		else if(DIAMAND)
		{
			EffaceShadow(x_shadow, y_shadow, piece, position);
			EffacePiece(x_piece, y_piece, piece, position);
			while(!TestCollision(x_piece, y_piece+6, position, piece))
			{
				y_piece += 6;
			}
			AffichePiece(x_piece, y_piece, piece, position);
			compteur = -1;
		}
		
		else if(ESCAPE)
		{
			if(!link)
			{
				AfficheQuit(&game_over);
			}
			else
			{
    		game_over = 1;
			}
		}
		
		else if(_keytest(QUICK_EXIT) && !link)    // Sort du jeu immdiatement
		{																					// et sauvegarde TOUT!!!
			entry = DerefSym(SymAddMain(SYMSTR("@tetrics"))); // Le symbole '@' rendra cette variable invisible du TIOS (merci Greg Dietsche !)
			Sauvegarde = (unsigned char*)HLock(entry->handle = HeapAlloc(7716));
			*(unsigned short*)Sauvegarde = 7714;
			*(Sauvegarde+7709) = 0;
			strcpy(Sauvegarde+77010, extension);
			*(Sauvegarde+7715) = OTH_TAG;
			FastCopyScreen_R(plan0, Sauvegarde+2);
			FastCopyScreen_R(plan1, Sauvegarde+2+LCD_SIZE);
			*(unsigned short *)(Sauvegarde+7682) = piece;
			*(unsigned short *)(Sauvegarde+7684) = next_piece;
			*(unsigned short *)(Sauvegarde+7686) = compteur;
			*(unsigned short *)(Sauvegarde+7688) = decompte_score;
			*(unsigned short *)(Sauvegarde+7690) = position;
			*(unsigned short *)(Sauvegarde+7692) = x_piece;
			*(unsigned short *)(Sauvegarde+7694) = y_piece;
			*(unsigned short *)(Sauvegarde+7696) = niveau;
			*(unsigned short *)(Sauvegarde+7698) = lines;
			*(unsigned long *)(Sauvegarde+7700) = score;
			*(unsigned short *)(Sauvegarde+7704) = x_shadow;
			*(unsigned short *)(Sauvegarde+7706) = y_shadow;
			HeapUnlock(entry->handle);
			QUICK_EXIT_SAVE = 1;
			return 0;
		}
    
    else if(_keytest(RR_DOT) && !link)	// Sort du jeu immdiatement sans rien 
    {																		// sauvegarder (DOT = point ou virgule pour les dcimaux)
    	QUICK_EXIT_NO_SAVE = 1;
    	return 0;
    }
    
		if(link && game_over != 1)
		{
			if(OSReadLinkBlock(buffer_link, 1))
			{		
				if(buffer_link[0] == -1)	// L'autre calc a t teinte => je m'teins aussi
				{
					off();
				}
				else if(buffer_link[0] == 22)
				{
					game_over = 1;
					win_flag = 1; 							 // J'ai gagn puisque l'autre est mort...
				}
				else if(buffer_link[0] == 21)
				{
					game_over = 1;	// J'ai perdu puisque l'autre a complt ses lignes...
				}
				else if(buffer_link[0] > 22)
				{
					DessineHauteur(buffer_link[0]-23);
				}
				else if((buffer_link[0] > 0 && buffer_link[0] < 4))
				{
					i = buffer_link[0] == 3? 4: buffer_link[0];
					EffaceShadow(x_shadow, y_shadow, piece, position);
	  			EffacePiece(x_piece, y_piece, piece, position);
					j = y_piece;
					y_piece = y_piece-6*i >= -12? y_piece-6*i: -12;
					decompte_score = (decompte_score-(j-y_piece)/6) >= 0? (decompte_score-(j-y_piece)/6): 0;
					high_blocs -= 6*i;
					EnvoieByte(buffer_link, high_blocs+23);
					char pic_0[1000], pic_1[1000];
					SCR_RECT sauv = {{16+ADAPT_x, ADAPT_y+6*i, 95+ADAPT_x, ADAPT_y+95}};
      		GraySetAMSPlane(GRIS_CLAIR);
	    		BitmapGet(&sauv, pic_0);
	    		GraySetAMSPlane(GRIS_FONCE);
	    		BitmapGet(&sauv, pic_1);
	    		DessineRectPlein(16, 96-6*i, 95, 95, 0, GRIS_CLAIR);
	    		DessineRectPlein(16, 96-6*i, 95, 95, 0, GRIS_FONCE);
	    		AfficheBmp(16, 0, pic_0, 4, GRIS_CLAIR);
		  		AfficheBmp(16, 0, pic_1, 4, GRIS_FONCE);
		  		DessineBlocs(i);
		  		x_shadow = x_piece;
					y_shadow = y_piece;
		  		DessineShadow(&x_shadow, &y_shadow, piece, position);
	  			AffichePiece(x_piece, y_piece, piece, position);
				}
			}
		}		
			  
	}
																																								
 //===================================================================================//
 //																Fin de la boucle while														  //
 //===================================================================================//				
	
	if(win_flag == 0)
	{
		if(link)
		{
			EnvoieByte(buffer_link, 22);						// 22! Je suis mort!
			losses ++;
		}
		AfficheMessage("Game over...");
		if(wins + losses == 4)
		{
		  PressionTouche(TESTE_ET_SORT);
			EnterEsc();
		  DessineFin(wins, losses);
		  wins = 0;
		  losses = 0;
		}
	}
	else
	{
		wins ++;
		AfficheMessage("YOU WIN!");
		if(wins + losses == 4)
		{
			PressionTouche(TESTE_ET_SORT);
			EnterEsc();
			DessineFin(wins, losses);
			wins = 0;
			losses = 0;
		}
	}
	OSLinkClose();
	PressionTouche(TESTE_ET_SORT);
	EnterEsc();
	if(score > hscore[4].score)
	{
		HighScore(score);
		return (wins + losses);
	}
	else
	{
		FonduBas(EFFACE_DEUX_PLANS);
		if(!TI89)
		{
			FondEcran();
			EffacePlans();
		} 
		MenuFond();
		MenuScores();
		EnterEsc();
		return (wins + losses);
	}
}

 //===================================================================================//
 //                     Fonction appele au lancement du jeu									  			//
 //===================================================================================//

// 																ATTENTION !!!!!!!!!!!	

//	Bien penser  archiver et  dsarchiver la variable de sauvegarde AVANT de			 //
//  rediriger les interruptions et APRES les avoir restaures. En fait, lorsque			 //
//	qu'on n'implmente pas de son on peut se permettre de transgresser ce principe	 //
//	mais quand on en a implment, sa transgression provoque des plantages					 //
//	intempestifs.
//===================================================================================//

void _main(void)
{
	char r, s;
	register short y_menu, nombre_jeu, i, j, k, l, m, n;
	
	y_menu = 20;
	nombre_jeu = 0;
	
	unsigned char * screen = NULL;
	screen = malloc(LCD_SIZE);
	FastCopyScreen_R(LCD_MEM, screen);
	EM_moveSymFromExtMem(SYMSTR("tetsav"), HS_NULL);		// <--- Attention ! Dsarchive la variable 'tetsav'
	RedirigeInterruptions();
	OSLinkReset();
	OuvreFichierSauvegarde();
	
	entry = DerefSym(SymFindMain(SYMSTR("@tetrics")));
	if (entry != NULL)
	{
		Sauvegarde = (unsigned char*)HLock(entry->handle);
		QUICK_EXIT_SAVE = 1;
		goto START_GAME_SAVED;
	}
	
	if(!TI89)
	{
		FonduBas(EFFACE_DEUX_PLANS);
		FondEcran();
		FonduHaut();
	}
	EffetSprite(intro_0, intro_1);
	PressionTouche(NE_FAIT_RIEN);
	
	Menu:
	
	FonduBas(EFFACE_DEUX_PLANS);	 
	MenuFond();
	MenuGeneral();
	DessineRectPlein(16, y_menu, 143, y_menu+11, 2, GRIS_FONCE);
	FonduHaut();
	

	do
	{
		PressionTouche(NE_FAIT_RIEN);
	  
	  if(HAUT)
	  {
	  	DessineRectPlein(16, y_menu, 143, y_menu+11, 2, GRIS_FONCE);
	  	y_menu = (y_menu == 20 ? 68: y_menu-12);
	  	DessineRectPlein(16, y_menu, 143, y_menu+11, 2, GRIS_FONCE);
	  }
		if(BAS)
		{
			DessineRectPlein(16, y_menu, 143, y_menu+11, 2, GRIS_FONCE);
	  	y_menu = (y_menu == 68 ? 20: y_menu+12);
	  	DessineRectPlein(16, y_menu, 143, y_menu+11, 2, GRIS_FONCE);
		}
		if(ENTER || SECOND)
		{
			if(y_menu == 68)
			{
				break;
			}
			else if(y_menu != 20)
			{
				FonduBas(EFFACE_RECT_MENU);
			}
			switch(y_menu)
			{
				case 20:
				if(link)
				{
					FonduBas(EFFACE_DEUX_PLANS);
					AfficheMessage("Waiting...");
					AfficheChaine(41, 59, "PRESS [ESC] TO CANCEL", 4, GRIS_CLAIR, PETIT);
					AfficheChaine(41, 59, "PRESS [ESC] TO CANCEL", 4, GRIS_FONCE, PETIT);
					AfficheChaine(2, 71, "A game is won by the first to either complete", 4, GRIS_FONCE, PETIT);
					AfficheChaine(2, 77, "30 lines or push all the opponent's lines up", 4, GRIS_FONCE, PETIT);					
					AfficheChaine(2, 83, "to the top of the game field. The first to win", 4, GRIS_FONCE, PETIT);
					AfficheChaine(2, 89, "four games wins. Good Luck!", 4, GRIS_FONCE, PETIT);
					printf_xy(ADAPT_x+122, ADAPT_y+93, "Game: %d/4", nombre_jeu);
					DessineRectPlein(0, 0, 159, 18, 4, GRIS_CLAIR);
					DessineLigne(2, 2, 157, 2, 0, GRIS_CLAIR);
					DessineLigne(2, 2, 2, 15, 0, GRIS_CLAIR);
					DessineLigne(157, 3, 157, 16, 4, GRIS_FONCE);
					DessineLigne(2, 16, 157, 16, 4, GRIS_FONCE);
					Draw_SPECIAL(3, 5, "mario vs luigi", plan0, 0);
					Draw_SPECIAL(4, 6, "mario vs luigi", plan1, 0);
					Sprite16_GRIS_XOR(20, 21, mario_0, mario_1);
					Sprite16_GRIS_XOR(122, 21, luigi_0, luigi_1);
					DessineLigne(37, 31, 120, 31, 4, GRIS_CLAIR);
					DessineLigne(37, 31, 120, 31, 4, GRIS_FONCE);
					FonduHaut();
					OSLinkOpen();
					s = 5;
					r = 0;
					i = 1;
					j = 37;
					k = 115;
					l = 0;
					m = 30;
					n = 32;
					OSWriteLinkBlock(&s, 1);
					for(;;)
					{
						l %= 30000;
						
						if((l ++)%55 == 0)
						{
							DessineLigne(j, m, j+5, m, 0, GRIS_FONCE);
							DessineLigne(k, n, k+5, n, 0, GRIS_FONCE);
							j += i;
							k -= i;
							if(j == 115 || j == 37)
							{
								i = -i;
								m = (m == 30 ? 32: 30);
								n = (n == 30 ? 32: 30);
							}	
							DessineLigne(j, m, j+5, m, 4, GRIS_FONCE);
							DessineLigne(k, n, k+5, n, 4, GRIS_FONCE);												 	 
						}
												
						if(OSReadLinkBlock(&r, 1))
						{
							if(r == 5)								// Joueur le plus rapide => MARIO
							{
								s = 6;
								OSWriteLinkBlock(&s, 1);
								if(nombre_jeu == 0)
								 joueur = MARIO;
								break;
							}
							else if(r == 6)					 // Joueur le moins rapide => LUIGI
							{
								if(nombre_jeu == 0)
								 joueur = LUIGI;
								break;
							}
							else
							{
								s = 5;
								OSWriteLinkBlock(&s, 1);
							}
						}
						PressionTouche(TESTE_ET_SORT);
						if(ESCAPE)
						{
							OSLinkClose();
							goto Menu;
						}			 
					}
				}
				START_GAME_SAVED:
				nombre_jeu = Jeu();
				if(QUICK_EXIT_SAVE || QUICK_EXIT_NO_SAVE)
				{
					goto FIN_DU_JEU;
				}
				goto Menu;
				case 32:
				MenuOptions();
				goto Menu;
				case 44:
				MenuScores();
				EnterEsc();
				goto Menu;
				case 56:
				MenuAbout();
				goto Menu;
			}
		}	
	}while(!ESCAPE);

	FIN_DU_JEU:
	FermeFichierSauvegarde();
	PortRestore();
	if(QUICK_EXIT_SAVE || QUICK_EXIT_NO_SAVE)
	{
		FastCopyScreen_R(screen, plan0);
		FastCopyScreen_R(screen, plan1);
	}
	else
	{
		EffetLCD(screen, screen);
	}
	free(screen);
	RestaureInterruptions();
	ST_helpMsg("Tetrics by Nul v"VERSION);
	GKeyFlush();// Permet de ne pas relancer le programme lorsqu'on est revenu dans HOME si on a laiss appuye la touche [ENTER]
	if(!QUICK_EXIT_SAVE)					// On efface la variable '@tetrics' si on n'a
	{															// pas appuy sur [HOME]/[F8] pendant le jeu.
		SymDel(SYMSTR("@tetrics"));
	}	
	EM_moveSymToExtMem(SYMSTR("tetsav"), HS_NULL); // <--- Attention ! Archive la variable 'tetsauv'
}

//=============================================================================//
//															THE END																				 //
//=============================================================================//